# Turn off the brp-python-bytecompile script
%define __brp_python_bytecompile %{nil}
# needs porting of Mandriva specific features from hal-cups-utils to s-c-p-udev
%define         obsolete_hal_cups_utils 1
%define cups_serverbin %{_exec_prefix}/lib/cups
%define cupservdir /usr/lib/cups


Name:           system-config-printer
Summary:        A printer administration tool
Version:        1.5.18
Release:        %mkrel 1
Url:            https://github.com/zdohnal/system-config-printer
License:        LGPLv2+
Group:          System/Printing
Source0:        https://github.com/OpenPrinting/system-config-printer/releases/download/v%{version}/%{name}-%{version}.tar.xz
Source1:        system-config-printer.pam
Source2:        system-config-printer.console
Source3:        po-mga.tar.bz2
Source4:        mga_printer_custom.py
Source5:        hp-makeuri-mga.c
Source6:        mga_backend
Source7:        69-printers_lp_user_fix.rules
# Fedora patches from upstream

Patch101:  	system-config-printer-mga-pclos-mdv.patch
Patch102:  	67_match-usb-uris-of-usblp-and-libusb.patch
Patch103: 	system-config-printer-lowercase-mfg-mdl.patch
# Mageia patches
Patch200:       system-config-printer-1.5.0-mga_custom-applet.patch
#Patch202:       system-config-printer-1.4.2-mga_custom-system-config-printer.patch
# new P202
Patch202:       system-config-printer-1.5.6-mga_custom-system-config-printer.patch
Patch203:       system-config-printer-1.5.2-start-applet.patch
Patch204:       system-config-printer-1.4.4-udev-configure-printer-mga.patch
Patch300:       system-config-printer-1.3.7-remove-Brother-HL-2030-blacklist.patch
Patch301:       system-config-printer-1.5.5-mga_visual-artifacts.patch
# mga #15549
Patch302:	apply-new-udev-rules.patch
Patch303:	avoid-reinstall-of-libsane-hpaio.patch


#Upstream patches

BuildRequires:  cups-devel >= 1.2
BuildRequires:  desktop-file-utils >= 0.2.92
BuildRequires:  gettext-devel
BuildRequires:  intltool
BuildRequires:  pkgconfig(libusb)
BuildRequires:  pkgconfig(glib-2.0)
BuildRequires:  xmlto
BuildRequires:  python3-cups
BuildRequires:  pkgconfig(python3)
BuildRequires:  pkgconfig(pygobject-3.0)
BuildRequires:  pkgconfig(py3cairo)
BuildRequires:  pkgconfig(udev)
BuildRequires:  hplip-devel
BuildRequires:  pkgconfig(dbus-1)
BuildRequires:  pkgconfig(dbus-glib-1)

Obsoletes:      desktop-printing
Obsoletes:      printerdrake

Provides:       printerdrake
Requires:       python3-gobject3
Requires:       gtk+3.0
Requires:       desktop-file-utils >= 0.2.92
Requires:       dbus-x11
# not, no it is needed on pclos, we use our own 
Requires:       cups-pk-helper
Requires:       system-config-printer-libs >= %{version}-%{release}
%if %obsolete_hal_cups_utils
Requires:       system-config-printer-udev >= %{version}-%{release}
%else
Requires:       hal-cups-utils
%endif
Requires:       virtual-notification-daemon
Requires:       python3-cups
#Requires:       python-rhpl
Requires:       python3-dbus
Requires:       python3-cairo
Requires:       python3-requests
Requires:       python3-notify2
%if %obsolete_hal_cups_utils
Requires:       hplip-hpijs
Requires:       nmap
Requires:       python-smbc
%endif
Conflicts:      kdeutils4-printer-applet
# nmap is required to scan the network, just like
# printerdrake used to do.
Requires:       nmap
#Recommends:       samba-client
# (cg) Required for CheckUSBPermissions.py
Requires:       acl
Requires:     python-smbc

%description
system-config-printer is a graphical user interface that allows
the user to configure a CUPS print server.

%files
%{_sbindir}/%{name}
%{_bindir}/%{name}
%{_bindir}/hp-makeuri-mga
%{_bindir}/install-printerdriver
%{_datadir}/%{name}/check-device-ids.py*
%{_datadir}/%{name}/HIG.py*
%{_datadir}/%{name}/SearchCriterion.py*
%{_datadir}/%{name}/serversettings.py*
%{_datadir}/%{name}/system-config-printer.py*
%{_datadir}/%{name}/ToolbarSearchEntry.py*
%{_datadir}/%{name}/userdefault.py*
%{_datadir}/%{name}/troubleshoot
%{_datadir}/%{name}/icons
%{_datadir}/%{name}/install-printerdriver.py*
%dir %{_datadir}/%{name}/xml
%{_datadir}/%{name}/xml/*.rng
%{_datadir}/%{name}/xml/validate.py*
%dir %{_datadir}/%{name}/ui
%{_datadir}/%{name}/ui/*.ui
%{_datadir}/applications/system-config-printer.desktop
%{_datadir}/metainfo/%{name}.appdata.xml
%{_mandir}/man1/%{name}.1*

#---------------------------------------------------------------------
%package udev
Summary:        Rules for udev for automatic configuration of USB printers
Group:          System/Kernel and hardware
Requires:       system-config-printer-libs = %{version}-%{release}
Requires(post): rpm-helper
Requires(preun):rpm-helper
Obsoletes:      hal-cups-utils <= 0.6.20
Conflicts:      cups < 1.4.2-6

%description udev
The udev rules and helper programs for automatically configuring USB
printers.

%post
# disable old printer detection system
if [ -f /etc/sysconfig/printing ]; then
    if grep -q ^AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED= /etc/sysconfig/printing; then
        sed -i 's/AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED=.*/AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED=no/g' /etc/sysconfig/printing
    else
        echo AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED=no >> /etc/sysconfig/printing
    fi
    if grep -q ^ENABLE_QUEUES_ON_PRINTER_CONNECTED= /etc/sysconfig/printing; then
        sed -i 's/ENABLE_QUEUES_ON_PRINTER_CONNECTED=.*/ENABLE_QUEUES_ON_PRINTER_CONNECTED=no/g' /etc/sysconfig/printing
    else
        echo ENABLE_QUEUES_ON_PRINTER_CONNECTED=no >> /etc/sysconfig/printing
    fi
else
    echo AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED=no >> /etc/sysconfig/printing
    echo ENABLE_QUEUES_ON_PRINTER_CONNECTED=no >> /etc/sysconfig/printing
fi

%postun
# enable old printer detection system
if [ -f /etc/sysconfig/printing ]; then
    if grep -q ^AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED= /etc/sysconfig/printing; then
        sed -i 's/AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED=.*/AUTO_SETUP_QUEUES_ON_PRINTER_CONNECTED=yes/g' /etc/sysconfig/printing
    fi
    if grep -q ^ENABLE_QUEUES_ON_PRINTER_CONNECTED= /etc/sysconfig/printing; then
        sed -i 's/ENABLE_QUEUES_ON_PRINTER_CONNECTED=.*/ENABLE_QUEUES_ON_PRINTER_CONNECTED=yes/g' /etc/sysconfig/printing
    fi
fi

%files udev
/etc/udev/rules.d/69-printers_lp_user_fix.rules
/lib/udev/rules.d/70-printers.rules
/lib/udev/udev-add-printer
/lib/udev/udev-configure-printer
%ghost %dir %{_localstatedir}/run/udev-configure-printer
%ghost %verify(not md5 size mtime) %config(noreplace,missingok) %attr(0644,root,root) %{_localstatedir}/run/udev-configure-printer/usb-uris
### {_unitdir}/configure-printer@.service

#---------------------------------------------------------------------

%package  libs
Summary:   Common code for the graphical and non-graphical pieces
Group:     System/Libraries
Requires:  python3-cups
Requires:  python3-pycurl
Requires:  gobject-introspection
Requires:  python3-gobject3
Requires:  gtk+3.0
Requires:  python3-dbus
Recommends: python-pysmbc

%description libs
The common code used by both the graphical and non-graphical parts of
the configuration tool.

%files libs -f system-config-printer.lang
%config(noreplace) %{_sysconfdir}/dbus-1/system.d/com.redhat.NewPrinterNotification.conf
%config(noreplace) %{_sysconfdir}/dbus-1/system.d/com.redhat.PrinterDriversInstaller.conf
%config(noreplace) %{_sysconfdir}/pam.d/system-config-printer
%config(noreplace) %{_sysconfdir}/security/console.apps/system-config-printer
%{_datadir}/dbus-1/interfaces/*.xml
%{_datadir}/dbus-1/services/*.service
%{_bindir}/scp-dbus-service
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/asyncconn.py*
%{_datadir}/%{name}/asyncipp.py*
%{_datadir}/%{name}/asyncpk1.py*
%{_datadir}/%{name}/authconn.py*
%{_datadir}/%{name}/config.py*
%{_datadir}/%{name}/cupspk.py*
%{_datadir}/%{name}/debug.py*
%{_datadir}/%{name}/dnssdresolve.py*
%{_datadir}/%{name}/errordialogs.py*
%{_datadir}/%{name}/firewallsettings.py*
%{_datadir}/%{name}/gtkinklevel.py*
%{_datadir}/%{name}/gui.py*
%{_datadir}/%{name}/installpackage.py*
%{_datadir}/%{name}/jobviewer.py*
%{_datadir}/%{name}/killtimer.py*
%{_datadir}/%{name}/monitor.py*
%{_datadir}/%{name}/newprinter.py*
%{_datadir}/%{name}/options.py*
%{_datadir}/%{name}/optionwidgets.py*
%{_datadir}/%{name}/OpenPrintingRequest.py
%{_datadir}/%{name}/PhysicalDevice.py*
%{_datadir}/%{name}/ppdcache.py*
%{_datadir}/%{name}/ppdippstr.py*
%{_datadir}/%{name}/ppdsloader.py*
%{_datadir}/%{name}/printerproperties.py*
%{_datadir}/%{name}/probe_printer.py*
%{_datadir}/%{name}/pysmb.py*
%{_datadir}/%{name}/scp-dbus-service.py*
%{_datadir}/%{name}/smburi.py*
%{_datadir}/%{name}/statereason.py*
%{_datadir}/%{name}/timedops.py*
# for debuging
%{_datadir}/%{name}/__pycache__/*.cpython-310.pyc
%{_datadir}/%{name}/xml/__pycache__/validate.cpython-310.pyc
%dir %{_sysconfdir}/cupshelpers
%config(noreplace) %{_sysconfdir}/cupshelpers/preferreddrivers.xml
%{py3_platsitedir}/__pycache__/mga_printer_custom.cpython-310.pyc
%{py3_platsitedir}/mga_printer_custom.py
%{python3_sitelib}/cupshelpers/*.py
%{python3_sitelib}/cupshelpers-1.0-py3.10.egg
###/usr/lib64/python2.7/site-packages/mga_printer_custom.py
%{_prefix}/lib/cups/backend/mga_backend
%{_datadir}/%{name}/mga_printer_custom.py*

#--------------------------------------------------------------------

%package applet
Summary: Print job notification applet
Group: System/Printing
Requires: %{name}-libs

%description applet
Print job notification applet.

%files applet
%{_bindir}/%{name}-applet
%{_datadir}/%{name}/applet.py*
%{_sysconfdir}/xdg/autostart/print-applet.desktop
%{_mandir}/man1/%{name}-applet.1*

#--------------------------------------------------------------------

%prep
%setup -q
# Fedora patches from upstream

%patch101 -p1  	
###%patch102 -p1  	
###%patch103 -p1

%patch200 -p1 -b .mga_custom-applet
%patch202 -p1 -b .mga_custom-system-config-printer
%patch203 -p1 -b .start_applet
%patch204 -p1 -b .udev-configue-printer-mga

%patch300 -p0 -b .mga-1349
%patch301 -p0 -b .mga-14981
%patch302 -p0
%patch303 -p0


# update mga custom translation
tar xvjf %{SOURCE3}
pushd po
for i in *.po; do
    if [ ! -f ../po-mga/$i ]; then
        continue
    fi
    msgcat $i ../po-mga/$i > ../po-mga/$i-new
    rm -f $i
    mv ../po-mga/$i-new $i
done
popd

%build
./bootstrap

autoreconf -vfi

CFLAGS+=' -fcommon'
export LDFLAGS=" -L/usr/lib64/libglvnd/ -L/usr/lib64/libpython3.10 $LDFLAGS"
export LDFLAGS="-ldbus-1"

%configure2_5x --disable-rpath \
	--without-systemdsystemunitdir \
    --with-cups-serverbin-dir=%cupservdir \
%if %obsolete_hal_cups_utils
	--with-udev-rules
%endif

%__make
# (salem) this hack avoids requiring hplip
gcc %{SOURCE5} -o hp-makeuri-mga -lhpmud

perl -pi -e "s|desktop-file-install|desktop-file-install --vendor=''|" Makefile
perl -pi -e "s|category Printing|category X-MandrivaLinux-System-Configuration|" Makefile
perl -pi -e "s|category Monitor|category X-MandrivaLinux-System-Monitoring|" Makefile

%install
rm -rf %{buildroot}
%makeinstall_std

cp -f hp-makeuri-mga %{buildroot}%{_bindir}
cp -fv %{SOURCE4} %{buildroot}%{_datadir}/%{name}

%{__mkdir_p} %buildroot%{_localstatedir}/run/udev-configure-printer
touch %buildroot%{_localstatedir}/run/udev-configure-printer/usb-uris
%if %obsolete_hal_cups_utils
mkdir -p %{buildroot}%{_mozillaextpath}
mkdir -p %{buildroot}%{py_platsitedir}
mkdir -p %{buildroot}%{_bindir}
cp -f hp-makeuri-mga %{buildroot}%{_bindir}
# Make sure pyc files are generated, otherwise we can get
# difficult to debug problems
pushd %{buildroot}%{_datadir}/%{name}
python3 -m compileall .
popd

mkdir -p %{buildroot}%{py3_platsitedir}
cp -fv %{SOURCE4} %{buildroot}%{py3_platsitedir}
pushd %{buildroot}%{py3_platsitedir}
python3 -m compileall .
popd

%{__mkdir_p} %buildroot/var/run/udev-configure-printer
touch %buildroot/var/run/udev-configure-printer/usb-uris
%{__mkdir_p} %{buildroot}/usr/lib/cups/backend
cp -f %{SOURCE6} %{buildroot}/usr/lib/cups/backend

# Install udev rules for letting backends access the printer devices.  Once
# CUPS runs backends as group 'lp', instead of 'sys, we may remove this.
mkdir -p %{buildroot}%{_sysconfdir}/udev/rules.d
install -m 644 %{SOURCE7} %{buildroot}%{_sysconfdir}/udev/rules.d/

%endif

mkdir -p %buildroot%{_bindir}
mkdir -p %buildroot%{_sbindir}
mkdir -p %buildroot%{_sysconfdir}/pam.d
mkdir -p %buildroot%{_sysconfdir}/security/console.apps
install -p -m0644 %{SOURCE1} %buildroot%{_sysconfdir}/pam.d/%{name}
install -p -m0644 %{SOURCE2} %buildroot%{_sysconfdir}/security/console.apps/%{name}
mv %buildroot%{_bindir}/%{name} %buildroot%{_sbindir}/%{name}
ln -s consolehelper %buildroot%{_bindir}/%{name}

perl -pi -e "s|Name=Printing|Name=Configure your Printer|" %buildroot/%{_datadir}/applications/system-config-printer.desktop

# install all helpers.pys
mkdir -p %{buildroot}%{python3_sitelib}/cupshelpers
cp -rf %{_builddir}/system-config-printer-1.5.18/build/lib/cupshelpers/*.py %{buildroot}%{python3_sitelib}/cupshelpers/

%find_lang system-config-printer

%clean
rm -rf %{buildroot}


%changelog
* Mon Jan 29 2024 onkelho <oh.quait at gmail.com> - 1.5.18-4quait2024
- rebuild
- remove req: python-rhpl
- updates in po/cs.po po/id.po

* Wed Oct 11 2023 onkelho <oh.quait at gmail.com> - 1.5.18-2pclos2023
- forgett rel 1 - realize cupshelpers/*.py's
- new version released on Aug. 30 2022
- rerequires cups-pk-helper

* Sun Feb 06 2022 onkelho <oh.quait at gmail.com> - 1.5.15-5pclos2022
- rebuild - fixes py 
- drop Requires: cups-pk-helper

* Sat Feb 05 2022 onkelho <oh.quait at gmail.com> - 1.5.15-4pclos2022
- rebuild - fix tabed error in system-config-printer.py patch 401

* Thu Feb 03 2022 onkelho <oh.quait at gmail.com> - 1.5.15-3pclos2022
- rebuild against rel2 cups
- allow apt-get in mga_printer-custom.py

* Tue Mar 16 2021 tmb <tmb> 1.5.15-2.mga9
+ Revision: 1703847
- rebuild for python 3.9

